//exec("./EComBricks.cs");
exec("./NOSBricks.cs");
exec("./supportFunctions.cs");

function fxDtsBrick::plantScreenBrick(%this,%pos,%rot,%sb)
{
	%aRot = IDtoRotation(%rot);
	%x = getWord(strReplace(%sb,"_"," "),0);
	%y = getWord(strReplace(%sb,"_"," "),1);
	if(%this.isEComBrick)
		%data = ECOMBrickScreenPrint;
	else if(%this.isNPCBrick)
		%data = brick1x1PrintData;
	%b = new fxDTSBrick()
	{
		angleID = %rot;
		colorID = %this.colorID;
		colorFXID = 0;
		shapeFXID = 0;
		printID = $PrintList::Letters[" "];
		dataBlock = %data;
		isBaseplate = false;
		isplanted = true;
		client = %this.getGroup().client;
	};
	%this.getGroup().add(%b);
	%b.stackBL_ID = %this.stackBL_ID;
	%b.setTrusted(1);
	%b.setTransform(vectorAdd(%pos,%this.position) SPC %aRot);
	%err = %b.plant();
	%b.bb = %this;
	%b.isScreenBrick = true;
	if(%err > 0)
	{
		%b.killBrick();
		%this.bb.sbfail = "Error: Screen cannot be planted here.";
		%this.killBrick();
		return;
	}
	if(%this.isEComBrick)
	{
		%this.sb[%sb] = %b;
		%b.x = %x;
		%b.y = %y;
	}
	else if(%this.isNPCBrick)
	{
		%b.setName("_" @ %this.MonName @ %x @ "_" @ %y);
		%b.addEvent(0,1,"onActivate","Self","NPC_TouchScreen",%this.MonName,%x,%y);
	}
}

package screenErr
{
	function fxDtsBrick::killBrick(%this)
	{
		if(%this.isScreenBrick && isObject(%this.bb))
			%this.bb.killBrick();
		for(%x=0;%x<%this.sw;%x++)
			for(%y=0;%y<%this.sh;%y++)
				if(isObject(%this.sb[%x,%y]))
					%this.sb[%x,%y].delete();
		if(%this.sbfail !$= "")
			commandtoclient(%this.client,'centerprint',%this.sbfail,3);
		Parent::killBrick(%this);
	}
};

activatePackage(screenErr);